/*
LedBatterie_mod


hiroi01iniLibraryg킹Ă炢܂B
LEDControl̃\[XQlɂĂ炢܂B
肪Ƃ܂B
*/

#include <pspkernel.h>
#include <pspctrl.h>
#include <pspimpose_driver.h>
#include <psppower.h>

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "libinip.h"

/*-----------------------------------------------------------------*/

PSP_MODULE_INFO("LedBatterie_mod", 0x1000, 0, 1);

#define INI_PATH "/ledbatterie_mod.ini"
#define MAX_LINE 32
#define MAX_LINE_SIZE 64

#define MS_LED 0
#define WLAN_LED 1
#define POWER_LED 2
#define BLUETOOTH_LED 3

#define STATE_ON 1
#define STATE_OFF 0

/*------------------------------------------------------------------*/
int main_thread(SceSize args, void *argp);
int module_start(SceSize args, void *argp);
int module_stop(SceSize args, void *argp);

void sceSysconCtrlLED(int, int);
/*------------------------------------------------------------------*/
typedef struct CONFIG {
	struct data{
		int time;
		int start;
		int end;
	} data[MAX_LINE];
	int num;
} CONFIG;


/*------------------------------------------------------------------*/

#define checkPercent(a0)\
	if(a0 < 0)a0 = 0;\
	else if(a0 > 100)a0 = 100;

#define checkTime(a0)\
	if(a0 <= 0)a0 = 1;

/*------------------------------------------------------------------*/
int readIni(CONFIG *conf, char *basepath)
{
	int i, ret = 0;
	char buf[256], *temp ,*next;
	SceUID fp;

	//ǂݍinit@C̃pX
	strcpy(buf, basepath);
	temp = strrchr(buf, '/');
	if( temp != NULL ) *temp = '\0';
	strcat(buf, INI_PATH);

	fp = sceIoOpen(buf, PSP_O_RDONLY, 0777);
	if(fp < 0)return -1;
	
	for(i=0; i < MAX_LINE;)
	{
		ret = ILPReadLine(fp, buf, MAX_LINE_SIZE);
		if(ret == 0)
		{
			break;
		}
		else if(ILPIsSkipLine(buf))
		{
			continue;
		} else {
			ILPRemoveSpaceAndNewline(buf);
			temp = buf;
			next = ILPChToken(temp, ",");
			if(next == NULL)continue;
			
			conf->data[i].time = atoi(temp);
			checkTime(conf->data[i].time);
			temp = next;
			next = ILPChToken(temp, ",");
			if(next == NULL)continue;
			
			conf->data[i].start = atoi(temp);
			checkPercent(conf->data[i].start);
			
			conf->data[i].end = atoi(next);
			checkPercent(conf->data[i].end);
			
			i++;
		}
	}
	sceIoClose(fp);
	conf->num = i;

	return 0;
}

/*------------------------------------------------------------------*/

int main_thread(SceSize args, void *argp)
{
	CONFIG conf;
	int battery, i;

	while( sceKernelFindModuleByName("sceKernelLibrary") == NULL )
	{
		sceKernelDelayThread(1000);
	}
	
	memset(&conf, 0, sizeof(conf));
	int ret = readIni(&conf, argp);
	if(ret < 0)return 1;
	
	while (1)
	{
		battery = scePowerGetBatteryLifePercent();
		for(i=0; i<conf.num; i++){
			if(conf.data[i].start <= battery && battery <= conf.data[i].end){
				sceSysconCtrlLED(POWER_LED, STATE_OFF);
				sceKernelDelayThread((int)(conf.data[i].time*1000));
				sceSysconCtrlLED(POWER_LED, STATE_ON);
				sceKernelDelayThread((int)(conf.data[i].time*1000));
				break;
			}
		}
		if(i == conf.num){
			sceKernelDelayThread(50000);
		}
	}

	return 0;
}

/*------------------------------------------------------------------*/

int module_start(SceSize args, void *argp)
{

	int thid = sceKernelCreateThread("LedBatterie_mod", main_thread, 32, 0x1000, 0, NULL);
	if(thid >= 0)sceKernelStartThread(thid, args, argp);

	return 0;
}


int module_stop(SceSize args, void *argp)
{
	return 0;
}

